Index: /bidspace/pom.xml
===================================================================
--- /bidspace/pom.xml	(revision 41)
+++ /bidspace/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>bidspace</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
@@ -43,5 +43,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /boa/pom.xml
===================================================================
--- /boa/pom.xml	(revision 41)
+++ /boa/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>boa</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 41)
+++ /collectparties.sh	(revision 42)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=2.0.5
+VERSION=2.0.6
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /events/pom.xml
===================================================================
--- /events/pom.xml	(revision 41)
+++ /events/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>events</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- /exampleparties/anac2019/agentgg/pom.xml	(revision 41)
+++ /exampleparties/anac2019/agentgg/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>2.0.5</version>  <!-- equals the geniusweb version -->
+	<version>2.0.6</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- /exampleparties/anac2019/winkyagent/pom.xml	(revision 41)
+++ /exampleparties/anac2019/winkyagent/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>2.0.5</version>  <!-- equals the geniusweb version -->
+	<version>2.0.6</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/boulware/pom.xml
===================================================================
--- /exampleparties/boulware/pom.xml	(revision 41)
+++ /exampleparties/boulware/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/comparebids/pom.xml
===================================================================
--- /exampleparties/comparebids/pom.xml	(revision 41)
+++ /exampleparties/comparebids/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/conceder/pom.xml
===================================================================
--- /exampleparties/conceder/pom.xml	(revision 41)
+++ /exampleparties/conceder/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/hardliner/pom.xml
===================================================================
--- /exampleparties/hardliner/pom.xml	(revision 41)
+++ /exampleparties/hardliner/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/humangui/pom.xml
===================================================================
--- /exampleparties/humangui/pom.xml	(revision 41)
+++ /exampleparties/humangui/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/linear/pom.xml
===================================================================
--- /exampleparties/linear/pom.xml	(revision 41)
+++ /exampleparties/linear/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
Index: /exampleparties/randomparty/pom.xml
===================================================================
--- /exampleparties/randomparty/pom.xml	(revision 41)
+++ /exampleparties/randomparty/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>2.0.5</version> <!-- equals the geniusweb version -->
+	<version>2.0.6</version> <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/randompartypy/pom.xml
===================================================================
--- /exampleparties/randompartypy/pom.xml	(revision 41)
+++ /exampleparties/randompartypy/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>2.0.5</version>  <!-- equals the geniusweb version -->
+	<version>2.0.6</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -48,5 +48,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/simpleboa/pom.xml
===================================================================
--- /exampleparties/simpleboa/pom.xml	(revision 41)
+++ /exampleparties/simpleboa/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleboaparty</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/simpleshaop/pom.xml
===================================================================
--- /exampleparties/simpleshaop/pom.xml	(revision 41)
+++ /exampleparties/simpleshaop/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 41)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 42)
@@ -110,5 +110,5 @@
 		if (estimatedProfile == null) {
 			estimatedProfile = new SimpleLinearOrdering(
-					profileint.getProfile());
+					(DefaultPartialOrdering) profileint.getProfile());
 		}
 
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 41)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/SimpleLinearOrdering.java	(revision 42)
@@ -11,5 +11,4 @@
 import geniusweb.issuevalue.Domain;
 import geniusweb.profile.DefaultPartialOrdering;
-import geniusweb.profile.Profile;
 import geniusweb.profile.utilityspace.UtilitySpace;
 
@@ -26,5 +25,5 @@
 	private final List<Bid> bids;
 
-	SimpleLinearOrdering(Profile profile) {
+	SimpleLinearOrdering(DefaultPartialOrdering profile) {
 		this(profile.getDomain(), getSortedBids(profile));
 	}
@@ -87,14 +86,9 @@
 	/**
 	 * 
-	 * @param profile the {@link Profile}
+	 * @param profile the {@link DefaultPartialOrdering}
 	 * @return a list of bids in the profile sorted from low to high utility.
 	 */
-	private static List<Bid> getSortedBids(Profile profile) {
-		if (!(profile instanceof DefaultPartialOrdering)) {
-			throw new UnsupportedOperationException(
-					"Only DefaultPartialOrdering supported");
-		}
-		DefaultPartialOrdering prof = (DefaultPartialOrdering) profile;
-		List<Bid> bidslist = prof.getBids();
+	private static List<Bid> getSortedBids(DefaultPartialOrdering profile) {
+		List<Bid> bidslist = profile.getBids();
 		// NOTE sort defaults to ascending order, this is missing in docs.
 		Collections.sort(bidslist, new Comparator<Bid>() {
@@ -102,5 +96,5 @@
 			@Override
 			public int compare(Bid b1, Bid b2) {
-				return prof.isPreferredOrEqual(b1, b2) ? 1 : -1;
+				return profile.isPreferredOrEqual(b1, b2) ? 1 : -1;
 			}
 
Index: /exampleparties/timedependentparty/pom.xml
===================================================================
--- /exampleparties/timedependentparty/pom.xml	(revision 41)
+++ /exampleparties/timedependentparty/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>2.0.5</version> <!-- equals the geniusweb version -->
+	<version>2.0.6</version> <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /ip/pom.xml
===================================================================
--- /ip/pom.xml	(revision 41)
+++ /ip/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>ip</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /issuevalue/pom.xml
===================================================================
--- /issuevalue/pom.xml	(revision 41)
+++ /issuevalue/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>issuevalue</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
@@ -93,5 +93,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java	(revision 41)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java	(revision 42)
@@ -32,8 +32,10 @@
 	@Override
 	public int hashCode() {
-		final int prime = 31;
-		int result = 1;
-		result = prime * result + ((value == null) ? 0 : value.hashCode());
-		return result;
+		// WORKAROUND FOR BigDecimal hashCode. NOT auto generated.
+		// Very large numbers and numbers that differ only in a fraction
+		// beyond reach of double may get the same hashcode,
+		// but this is not an issue as equal hashcode only indicates that
+		// numbers MAY be equal.
+		return Double.hashCode(value.doubleValue());
 	}
 
Index: /issuevalue/src/test/java/geniusweb/issuevalue/BidTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/BidTest.java	(revision 41)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/BidTest.java	(revision 42)
@@ -8,5 +8,4 @@
 import java.util.Arrays;
 import java.util.HashMap;
-import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
@@ -26,7 +25,8 @@
 	private final static String ISSUE2 = "issue2";
 	private final static Value VALUE2 = new NumberValue("10");
-	private final static List<List<Bid>> list = new LinkedList<>();
+	private final static Value VALUE3 = new NumberValue("1000");
+	private final static Value VALUE3b = new NumberValue("1e+3");
 
-	private final static Bid bid, bid1, bidb, bidc;
+	private final static Bid bid, bid1, bidb, bidc, bidd, bidd2;
 	static {
 		Map<String, Value> issuevalues = new HashMap<>();
@@ -56,13 +56,16 @@
 		bidc = new Bid(issuevaluesc);
 
-		list.add(Arrays.asList(bid, bid1));
-		list.add(Arrays.asList(bidb));
-		list.add(Arrays.asList(bidc));
+		Map<String, Value> issuevaluesd = new HashMap<>();
+		issuevaluesd.put(ISSUE1, VALUE3);
+		bidd = new Bid(issuevaluesd);
+		issuevaluesd.put(ISSUE1, VALUE3b);
+		bidd2 = new Bid(issuevaluesd);
+
 	}
 
 	@Override
 	public List<List<Bid>> getGeneralTestData() {
-
-		return list;
+		return Arrays.asList(Arrays.asList(bid, bid1), Arrays.asList(bidb),
+				Arrays.asList(bidc), Arrays.asList(bidd, bidd2));
 	}
 
@@ -72,7 +75,6 @@
 				"Bid\\{issue3=9012345678901234567.89, issue2=1, issue1=\"b\"\\}",
 				"Bid\\{issue2=1, issue1=\"b\"\\}",
-				"Bid\\{issue2=10, issue1=\"value1\"\\}"
-
-		);
+				"Bid\\{issue2=10, issue1=\"value1\"\\}",
+				"Bid\\{issue1=1...\\}");
 	}
 
Index: /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 41)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 42)
@@ -21,5 +21,7 @@
 	private final NumberValue value = new NumberValue("12.31");
 	private final NumberValue value1 = new NumberValue("12.31");
-	private final NumberValue valueb = new NumberValue("12.310000000000000001");
+	private final NumberValue valueb = new NumberValue("12.3100000000001");
+	private final NumberValue valuec = new NumberValue("1000");
+	private final NumberValue valuec2 = new NumberValue("1e+3");
 	private final String serialized = "12.31";
 
@@ -31,10 +33,11 @@
 	public List<List<NumberValue>> getGeneralTestData() {
 		return Arrays.asList(Arrays.asList(value, value1),
-				Arrays.asList(valueb));
+				Arrays.asList(valueb), Arrays.asList(valuec, valuec2));
 	}
 
 	@Override
 	public List<String> getGeneralTestStrings() {
-		return Arrays.asList("12.31", "12.310000000000000001");
+		// 1000 and 1e+3 are bot ok
+		return Arrays.asList("12.31", "12.3100000000001", "1...");
 	}
 
Index: /opponentmodel/pom.xml
===================================================================
--- /opponentmodel/pom.xml	(revision 41)
+++ /opponentmodel/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>opponentmodel</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /party/pom.xml
===================================================================
--- /party/pom.xml	(revision 41)
+++ /party/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>party</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -52,5 +52,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 		<dependency>
Index: /profile/pom.xml
===================================================================
--- /profile/pom.xml	(revision 41)
+++ /profile/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profile</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -42,5 +42,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 
Index: /profileconnection/pom.xml
===================================================================
--- /profileconnection/pom.xml	(revision 41)
+++ /profileconnection/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profileconnection</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
Index: /protocol/pom.xml
===================================================================
--- /protocol/pom.xml	(revision 41)
+++ /protocol/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>protocol</artifactId>
-	<version>2.0.5</version>
+	<version>2.0.6</version>
 	<packaging>jar</packaging>
 
@@ -56,5 +56,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 		<dependency>
Index: /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 41)
+++ /protocol/src/main/java/geniusweb/protocol/partyconnection/ProtocolToPartyConnFactory.java	(revision 42)
@@ -25,12 +25,25 @@
 	/**
 	 * Connects a set of References in one go, following a modified Banker's
-	 * algorthm.
+	 * algorithm. Only succeeds if all requested connections can be made.
 	 * 
 	 * @param references the list of references to connect with
-	 * @return a List of connections, one fore each Reference.
+	 * @return a List of connections, one fore each Reference. The URI Scheme
+	 *         deteremines how the connection to the party is created.
+	 *         Typically,
+	 *         <ul>
+	 *         <li>"classpath" assumes the file refers to an existing class on
+	 *         the classpath, directly to be instantiated.
+	 *         <li>"pythonpath" idem, but now the party is a python party.
+	 *         <li>"http" assumes the party is to be started on a partiesserver,
+	 *         where the partiesserver will convert the provided address to a
+	 *         specific party.
+	 *         </ul>
+	 *         It depends on the run system which of these protocols are
+	 *         actually supported, eg "pythonpath" is typically only supported
+	 *         for the python-based simplerunner.
 	 * @throws IOException             if a connection is failing irrecoverably.
 	 * @throws NoResourcesNowException is there are insufficient resources now.
-	 *                                 This also includes a suggested moment to
-	 *                                 retry.
+	 *                                 This exception includes a suggested
+	 *                                 moment to retry.
 	 */
 	List<ProtocolToPartyConn> connect(List<Reference> references)
Index: /pythonadapter/pom.xml
===================================================================
--- /pythonadapter/pom.xml	(revision 41)
+++ /pythonadapter/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>pythonadapter</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -37,5 +37,12 @@
 			<groupId>org.python</groupId>
 			<artifactId>jython-standalone</artifactId>
-			<version>2.7.0</version>
+			<version>2.7.2</version>
+		</dependency>
+
+		<dependency>
+			<groupId>junit</groupId>
+			<artifactId>junit</artifactId>
+			<version>4.12</version>
+			<scope>test</scope>
 		</dependency>
 
Index: /pythonadapter/src/test/java/geniusweb/pythonadapter/PythonPartyAdapterTest.java
===================================================================
--- /pythonadapter/src/test/java/geniusweb/pythonadapter/PythonPartyAdapterTest.java	(revision 42)
+++ /pythonadapter/src/test/java/geniusweb/pythonadapter/PythonPartyAdapterTest.java	(revision 42)
@@ -0,0 +1,16 @@
+package geniusweb.pythonadapter;
+
+import org.junit.Test;
+
+public class PythonPartyAdapterTest {
+	@Test
+	public void smoke() {
+		new PythonPartyAdapter() {
+			
+			@Override
+			public String getPythonClass() {
+				return "TestParty";
+			}
+		};
+	}
+}
Index: /pythonadapter/src/test/resources/TestParty.py
===================================================================
--- /pythonadapter/src/test/resources/TestParty.py	(revision 42)
+++ /pythonadapter/src/test/resources/TestParty.py	(revision 42)
@@ -0,0 +1,41 @@
+import time
+import traceback
+
+
+
+import java.math.BigInteger as BigInteger
+import java.net.URI as URI
+import java.util.Arrays as Arrays
+import java.util.HashSet as HashSet
+import java.util.Random as Random
+import java.util.Collections as Collections
+import java.util.logging.Level as Level
+ 
+import geniusweb.party.Capabilities as Capabilities
+import geniusweb.party.DefaultParty as DefaultParty
+
+
+import com.fasterxml.jackson.databind.ObjectMapper as ObjectMapper
+
+class TestParty (DefaultParty):
+	"""
+	A simple party that places random bids and accepts when it receives an offer
+	with sufficient utility.
+	"""
+
+	# Override
+	def notifyChange(self, info):
+		pass		
+
+	# Override
+	def getCapabilities(self): # -> Capabilities
+		pass
+		
+	# Override
+	def getDescription(self):
+		return "places random bids until it can accept an offer with utility >0.6. Python version"
+
+	# Override
+	def terminate(self):
+		pass
+
Index: /references/pom.xml
===================================================================
--- /references/pom.xml	(revision 41)
+++ /references/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>references</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -32,5 +32,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 		<!-- the core, which includes Streaming API, shared low-level abstractions 
Index: /simplerunner/pom.xml
===================================================================
--- /simplerunner/pom.xml	(revision 41)
+++ /simplerunner/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>simplerunner</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /timeline/pom.xml
===================================================================
--- /timeline/pom.xml	(revision 41)
+++ /timeline/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>timeline</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
Index: /voting/pom.xml
===================================================================
--- /voting/pom.xml	(revision 41)
+++ /voting/pom.xml	(revision 42)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>voting</artifactId>
-	<version>2.0.5</version> 
+	<version>2.0.6</version> 
 	<packaging>jar</packaging>
 
@@ -42,5 +42,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.0</version>
+			<version>1.1.1</version>
 		</dependency>
 		<!-- the core, which includes Streaming API, shared low-level abstractions 