Index: /bidspace/pom.xml
===================================================================
--- /bidspace/pom.xml	(revision 42)
+++ /bidspace/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>bidspace</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /bidspace/src/main/java/geniusweb/bidspace/Interval.java
===================================================================
--- /bidspace/src/main/java/geniusweb/bidspace/Interval.java	(revision 42)
+++ /bidspace/src/main/java/geniusweb/bidspace/Interval.java	(revision 43)
@@ -19,6 +19,6 @@
 	 * interval.
 	 * 
-	 * @param min the minimum value of the interval
-	 * @param max the maximum value of the interval
+	 * @param min the minimum value of the interval (inclusive)
+	 * @param max the maximum value of the interval (inclusive)
 	 */
 	public Interval(BigDecimal min, BigDecimal max) {
@@ -30,8 +30,16 @@
 	}
 
+	/**
+	 * 
+	 * @return the minimum value of the interval
+	 */
 	public BigDecimal getMin() {
 		return min;
 	}
 
+	/**
+	 * 
+	 * @return the maximum value of the interval
+	 */
 	public BigDecimal getMax() {
 		return max;
Index: /bidspace/src/test/resources/9issues/9issues1.json
===================================================================
--- /bidspace/src/test/resources/9issues/9issues1.json	(revision 42)
+++ /bidspace/src/test/resources/9issues/9issues1.json	(revision 43)
@@ -88,9 +88,9 @@
 		},
 		"issueWeights": {
-			"i1": 0.07531677352656704,
-			"i2": 0.18148468268008364,
-			"i3": 0.12035193969082373,
-			"i4": 0.21649985443378972,
-			"i5": 0.15621694966873587,
+			"i1": 0.07531677352656,
+			"i2": 0.18148468268008,
+			"i3": 0.12035193969082,
+			"i4": 0.21649985443378,
+			"i5": 0.15621694966876,
 			"i6": 0.111253,
 			"i7": 0.0656768,
Index: /boa/pom.xml
===================================================================
--- /boa/pom.xml	(revision 42)
+++ /boa/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>boa</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /collectparties.sh
===================================================================
--- /collectparties.sh	(revision 42)
+++ /collectparties.sh	(revision 43)
@@ -7,5 +7,5 @@
 rm -rf collectedparties
 mkdir collectedparties
-VERSION=2.0.6
+VERSION=2.0.7
 
 cp "exampleparties/anac2019/agentgg/target/agentgg-${VERSION}-jar-with-dependencies.jar" collectedparties
Index: /events/pom.xml
===================================================================
--- /events/pom.xml	(revision 42)
+++ /events/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>events</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- /exampleparties/anac2019/agentgg/pom.xml	(revision 42)
+++ /exampleparties/anac2019/agentgg/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>2.0.6</version>  <!-- equals the geniusweb version -->
+	<version>2.0.7</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: /exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- /exampleparties/anac2019/winkyagent/pom.xml	(revision 42)
+++ /exampleparties/anac2019/winkyagent/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>2.0.6</version>  <!-- equals the geniusweb version -->
+	<version>2.0.7</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: /exampleparties/boulware/pom.xml
===================================================================
--- /exampleparties/boulware/pom.xml	(revision 42)
+++ /exampleparties/boulware/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/comparebids/pom.xml
===================================================================
--- /exampleparties/comparebids/pom.xml	(revision 42)
+++ /exampleparties/comparebids/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /exampleparties/conceder/pom.xml
===================================================================
--- /exampleparties/conceder/pom.xml	(revision 42)
+++ /exampleparties/conceder/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/hardliner/pom.xml
===================================================================
--- /exampleparties/hardliner/pom.xml	(revision 42)
+++ /exampleparties/hardliner/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/humangui/pom.xml
===================================================================
--- /exampleparties/humangui/pom.xml	(revision 42)
+++ /exampleparties/humangui/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/linear/pom.xml
===================================================================
--- /exampleparties/linear/pom.xml	(revision 42)
+++ /exampleparties/linear/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /exampleparties/randomparty/pom.xml
===================================================================
--- /exampleparties/randomparty/pom.xml	(revision 42)
+++ /exampleparties/randomparty/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>2.0.6</version> <!-- equals the geniusweb version -->
+	<version>2.0.7</version> <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: /exampleparties/randompartypy/pom.xml
===================================================================
--- /exampleparties/randompartypy/pom.xml	(revision 42)
+++ /exampleparties/randompartypy/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>2.0.6</version>  <!-- equals the geniusweb version -->
+	<version>2.0.7</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: /exampleparties/simpleboa/pom.xml
===================================================================
--- /exampleparties/simpleboa/pom.xml	(revision 42)
+++ /exampleparties/simpleboa/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleboaparty</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/simpleshaop/pom.xml
===================================================================
--- /exampleparties/simpleshaop/pom.xml	(revision 42)
+++ /exampleparties/simpleshaop/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /exampleparties/timedependentparty/pom.xml
===================================================================
--- /exampleparties/timedependentparty/pom.xml	(revision 42)
+++ /exampleparties/timedependentparty/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>2.0.6</version> <!-- equals the geniusweb version -->
+	<version>2.0.7</version> <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java
===================================================================
--- /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 42)
+++ /exampleparties/timedependentparty/src/test/java/geniusweb/exampleparties/timedependentparty/TimeDependentPartyTest.java	(revision 43)
@@ -5,4 +5,5 @@
 import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertTrue;
+import static org.mockito.ArgumentMatchers.any;
 import static org.mockito.ArgumentMatchers.eq;
 import static org.mockito.Mockito.mock;
@@ -76,4 +77,5 @@
 			}
 		};
+		when(progress.get(any())).thenReturn(0d);
 		settings = new Settings(new PartyId("party1"),
 				new ProfileRef(new URI("file:" + PROFILE)), protocol, progress,
Index: /ip/pom.xml
===================================================================
--- /ip/pom.xml	(revision 42)
+++ /ip/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>ip</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /issuevalue/pom.xml
===================================================================
--- /issuevalue/pom.xml	(revision 42)
+++ /issuevalue/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>issuevalue</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /opponentmodel/pom.xml
===================================================================
--- /opponentmodel/pom.xml	(revision 42)
+++ /opponentmodel/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>opponentmodel</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /party/pom.xml
===================================================================
--- /party/pom.xml	(revision 42)
+++ /party/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>party</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /profile/pom.xml
===================================================================
--- /profile/pom.xml	(revision 42)
+++ /profile/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profile</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /profileconnection/pom.xml
===================================================================
--- /profileconnection/pom.xml	(revision 42)
+++ /profileconnection/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>profileconnection</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /protocol/pom.xml
===================================================================
--- /protocol/pom.xml	(revision 42)
+++ /protocol/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>protocol</artifactId>
-	<version>2.0.6</version>
+	<version>2.0.7</version>
 	<packaging>jar</packaging>
 
Index: /pythonadapter/pom.xml
===================================================================
--- /pythonadapter/pom.xml	(revision 42)
+++ /pythonadapter/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>pythonadapter</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /references/pom.xml
===================================================================
--- /references/pom.xml	(revision 42)
+++ /references/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>references</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /references/src/test/java/geniusweb/references/ParametersTest.java
===================================================================
--- /references/src/test/java/geniusweb/references/ParametersTest.java	(revision 42)
+++ /references/src/test/java/geniusweb/references/ParametersTest.java	(revision 43)
@@ -54,5 +54,5 @@
 
 		// a is integer!
-		assertEquals((Double) 1d, params2.getDouble("a", 1d, -0d, 2d));
+		assertEquals((Double) 1d, params2.getDouble("a", 0d, -0d, 2d));
 
 	}
Index: /simplerunner/pom.xml
===================================================================
--- /simplerunner/pom.xml	(revision 42)
+++ /simplerunner/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>simplerunner</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /timeline/pom.xml
===================================================================
--- /timeline/pom.xml	(revision 42)
+++ /timeline/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>timeline</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 
Index: /voting/pom.xml
===================================================================
--- /voting/pom.xml	(revision 42)
+++ /voting/pom.xml	(revision 43)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb</groupId>
 	<artifactId>voting</artifactId>
-	<version>2.0.6</version> 
+	<version>2.0.7</version> 
 	<packaging>jar</packaging>
 