Index: exampleparties/anac2019/agentgg/pom.xml
===================================================================
--- exampleparties/anac2019/agentgg/pom.xml	(revision 48)
+++ exampleparties/anac2019/agentgg/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>agentgg</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 
Index: exampleparties/anac2019/winkyagent/pom.xml
===================================================================
--- exampleparties/anac2019/winkyagent/pom.xml	(revision 48)
+++ exampleparties/anac2019/winkyagent/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties.anac2019</groupId>
 	<artifactId>winkyagent</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -60,5 +60,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 
Index: exampleparties/boulware/pom.xml
===================================================================
--- exampleparties/boulware/pom.xml	(revision 48)
+++ exampleparties/boulware/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>boulware</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/comparebids/pom.xml
===================================================================
--- exampleparties/comparebids/pom.xml	(revision 48)
+++ exampleparties/comparebids/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>comparebids</artifactId>
-	<version>2.1.3</version>
+	<version>2.1.4</version>
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 
Index: exampleparties/conceder/pom.xml
===================================================================
--- exampleparties/conceder/pom.xml	(revision 48)
+++ exampleparties/conceder/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>conceder</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/hardliner/pom.xml
===================================================================
--- exampleparties/hardliner/pom.xml	(revision 48)
+++ exampleparties/hardliner/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>hardliner</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/humangui/pom.xml
===================================================================
--- exampleparties/humangui/pom.xml	(revision 48)
+++ exampleparties/humangui/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>humangui</artifactId>
-	<version>2.1.3</version>
+	<version>2.1.4</version>
 	<packaging>jar</packaging>
 
Index: exampleparties/linear/pom.xml
===================================================================
--- exampleparties/linear/pom.xml	(revision 48)
+++ exampleparties/linear/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>linear</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/randomparty/pom.xml
===================================================================
--- exampleparties/randomparty/pom.xml	(revision 48)
+++ exampleparties/randomparty/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randomparty</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -55,5 +55,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 
Index: exampleparties/randompartypy/pom.xml
===================================================================
--- exampleparties/randompartypy/pom.xml	(revision 48)
+++ exampleparties/randompartypy/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>randompyparty</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/simpleboa/pom.xml
===================================================================
--- exampleparties/simpleboa/pom.xml	(revision 48)
+++ exampleparties/simpleboa/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleboaparty</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
Index: exampleparties/simpleshaop/pom.xml
===================================================================
--- exampleparties/simpleshaop/pom.xml	(revision 48)
+++ exampleparties/simpleshaop/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>simpleshaop</artifactId>
-	<version>2.1.3</version>
+	<version>2.1.4</version>
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 
Index: exampleparties/timedependentparty/pom.xml
===================================================================
--- exampleparties/timedependentparty/pom.xml	(revision 48)
+++ exampleparties/timedependentparty/pom.xml	(revision 49)
@@ -6,5 +6,5 @@
 	<groupId>geniusweb.exampleparties</groupId>
 	<artifactId>timedependentparty</artifactId>
-	<version>2.1.3</version>  <!-- equals the geniusweb version -->
+	<version>2.1.4</version>  <!-- equals the geniusweb version -->
 	<packaging>jar</packaging>
 
@@ -53,5 +53,5 @@
 			<groupId>tudelft.utilities</groupId>
 			<artifactId>utilities</artifactId>
-			<version>1.1.1</version>
+			<version>1.2.1</version>
 		</dependency>
 